var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => vitePluginImplicitCssModules
});
module.exports = __toCommonJS(src_exports);
function vitePluginImplicitCssModules() {
  return {
    name: "vite-plugin-implicit-css-modules",
    transform(src, id) {
      if (!/(\.vue)(\?[\w|=|&]+)?$/i.test(id)) {
        return src;
      }
      const reg = /<style(?:\slang="\w+")?\s*module(=["']\w+["'])?>[^<]+<\/style>/gim;
      const styleCodes = [...src.matchAll(reg)];
      if (!styleCodes || !styleCodes.length) {
        return src;
      }
      styleCodes.forEach((styleCode) => {
        const moduleId = getModuleId(styleCode);
        const templateReg = /<template>[\s\S]*<\/template>/gim;
        const templateCode = src.match(templateReg);
        if (templateCode) {
          const resolved = resolveCssModules(
            styleCode[0],
            templateCode[0],
            moduleId
          );
          src = src.replace(templateReg, resolved);
        }
      });
      return src;
    }
  };
}
function resolveCssModules(style, template, moduleId) {
  let styleStr = style.replace(/\/\*[\s\S]*?\*\/|([^:]|^)\/\/.*$/gm, "");
  styleStr = styleStr.replace(/:global[^{]*/gim, "");
  const classReg = /(?<=\.).+(?=\s*{)/gim;
  let classNames = styleStr.match(classReg);
  if (!classNames) {
    return template;
  }
  classNames = classNames.map((item) => item.trim());
  let result = template;
  classNames.forEach((className) => {
    const reg = new RegExp(`class="\\s*${className}\\s*"`, "gim");
    result = result.replace(reg, `:class="${moduleId}['${className}']"`);
  });
  const multiClassNames = result.match(/(?<!:)class="\s*[^\s|"]+\s+[^"]*"/gim);
  if (!multiClassNames) {
    return result;
  }
  multiClassNames.forEach((str) => {
    const classNameStr = str.replace(/class="/gim, "").replace(/"/gim, "");
    let classNameArr = classNameStr.split(" ");
    const moduleClassNameArr = classNameArr.filter(
      (item) => (classNames || []).includes(item)
    );
    let moduleClassStr = "";
    if (moduleClassNameArr.length) {
      moduleClassStr = ':class="[';
      moduleClassStr += moduleClassNameArr.map((item) => `${moduleId}['${item}']`).join(",");
      moduleClassStr += ']"';
    }
    classNameArr = classNameArr.filter(
      (item) => !(classNames || []).includes(item) && item
    );
    let classStr = "";
    if (classNameArr.length) {
      classStr = ` class="${classNameArr.join(" ")}"`;
    }
    result = result.replace(str, `${moduleClassStr}${classStr}`);
  });
  return result;
}
function getModuleId(styleCode) {
  if (styleCode == null ? void 0 : styleCode[1]) {
    return styleCode[1].replace(/=/i, "").replace(/["']/gi, "");
  }
  return "$style";
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
